package com.fp.persistence.parmas.param;

import java.io.Serializable;
import java.lang.reflect.Field;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.persistence.Version;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Parameter;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMTIPOARMAEXPLOSIVO*/
@Entity(name="TarmTipoArmaExplosivo")
@Table(name="TARMTIPOARMAEXPLOSIVO")
public class TarmTipoArmaExplosivo extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmTipoArmaExplosivo
*/
@Id
@Column(name="CTIPOARMAEXPLOSIVO" ,nullable=false, updatable=false)
@GenericGenerator(name = "seq_id", strategy = "com.fp.general.keygen.SequenceKey", parameters = {
        @Parameter(name = "name", value = "TARMTIPOARMAEXPLOSIVO"),//campo secuencial de la tabla
        @Parameter(name = "type", value = "java.lang.String"),// tipo de dato
        @Parameter(name = "fill", value = "0"),
        @Parameter(name = "length", value = "6")})
    @GeneratedValue(generator = "seq_id")
private String pk;
@Column(name="LONGITUD", nullable=true)

/**
* Codigo de catalogo  01 Natural, 02 Juridico
*/
private String longitud;

@Column(name="LONGITUDCODIGO", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String longitudcodigo;

@Column(name="CALIBRE", nullable=true)

/**
* Codigo de catalogo  01 Natural, 02 Juridico
*/
private String calibre;

@Column(name="CALIBRECODIGO", nullable=true)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String calibrecodigo;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* null
*/
private Integer recordversion;

@Column(name="CLASE", nullable=true)

/**
* null
*/
private String clase;

@Column(name="TIPOARMAEXPLOSIVO", nullable=true)

/**
* null
*/
private String tipoarmaexplosivo;

@Column(name="TIPOARMAEXPLOSIVOCODIGO", nullable=true)

/**
* null
*/
private String tipoarmaexplosivocodigo;

@Column(name="UNIDADMEDIDAPESO", nullable=true)

/**
* null
*/
private String unidadmedidapeso;

@Column(name="UNIDADMEDIDAPESOCODIGO", nullable=true)

/**
* null
*/
private String unidadmedidapesocodigo;

@Column(name="CLASECODIGO", nullable=true)

/**
* null
*/
private String clasecodigo;

/**Contructor por defecto*/
public TarmTipoArmaExplosivo(){
}
/**Contructor de TarmTipoArmaExplosivo
@param pPk Clave Primaria del entity
*/
public TarmTipoArmaExplosivo(String pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmTipoArmaExplosivo
*/
public static TarmTipoArmaExplosivo find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmTipoArmaExplosivo obj = pEntityManager.find(TarmTipoArmaExplosivo.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmTipoArmaExplosivo
@return El objeto que referencia a la Clave primaria de TarmTipoArmaExplosivo
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmTipoArmaExplosivo
@param pPk El objeto que referencia a la nueva Clave primaria de TarmTipoArmaExplosivo
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de longitud
@return valor de longitud*/
public String getLongitud(){
  return longitud;
}
/**Fija el valor de longitud
@param pLongitud nuevo Valor de longitud*/
public void setLongitud(String pLongitud){
  longitud=pLongitud;
}

/**Obtiene el valor de longitudcodigo
@return valor de longitudcodigo*/
public String getLongitudcodigo(){
  return longitudcodigo;
}
/**Fija el valor de longitudcodigo
@param pLongitudcodigo nuevo Valor de longitudcodigo*/
public void setLongitudcodigo(String pLongitudcodigo){
  longitudcodigo=pLongitudcodigo;
}

/**Obtiene el valor de calibre
@return valor de calibre*/
public String getCalibre(){
  return calibre;
}
/**Fija el valor de calibre
@param pCalibre nuevo Valor de calibre*/
public void setCalibre(String pCalibre){
  calibre=pCalibre;
}

/**Obtiene el valor de calibrecodigo
@return valor de calibrecodigo*/
public String getCalibrecodigo(){
  return calibrecodigo;
}
/**Fija el valor de calibrecodigo
@param pCalibrecodigo nuevo Valor de calibrecodigo*/
public void setCalibrecodigo(String pCalibrecodigo){
  calibrecodigo=pCalibrecodigo;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de clase
@return valor de clase*/
public String getClase(){
  return clase;
}
/**Fija el valor de clase
@param pClase nuevo Valor de clase*/
public void setClase(String pClase){
  clase=pClase;
}

/**Obtiene el valor de tipoarmaexplosivo
@return valor de tipoarmaexplosivo*/
public String getTipoarmaexplosivo(){
  return tipoarmaexplosivo;
}
/**Fija el valor de tipoarmaexplosivo
@param pTipoarmaexplosivo nuevo Valor de tipoarmaexplosivo*/
public void setTipoarmaexplosivo(String pTipoarmaexplosivo){
  tipoarmaexplosivo=pTipoarmaexplosivo;
}

/**Obtiene el valor de tipoarmaexplosivocodigo
@return valor de tipoarmaexplosivocodigo*/
public String getTipoarmaexplosivocodigo(){
  return tipoarmaexplosivocodigo;
}
/**Fija el valor de tipoarmaexplosivocodigo
@param pTipoarmaexplosivocodigo nuevo Valor de tipoarmaexplosivocodigo*/
public void setTipoarmaexplosivocodigo(String pTipoarmaexplosivocodigo){
  tipoarmaexplosivocodigo=pTipoarmaexplosivocodigo;
}

/**Obtiene el valor de unidadmedidapeso
@return valor de unidadmedidapeso*/
public String getUnidadmedidapeso(){
  return unidadmedidapeso;
}
/**Fija el valor de unidadmedidapeso
@param pUnidadmedidapeso nuevo Valor de unidadmedidapeso*/
public void setUnidadmedidapeso(String pUnidadmedidapeso){
  unidadmedidapeso=pUnidadmedidapeso;
}

/**Obtiene el valor de unidadmedidapesocodigo
@return valor de unidadmedidapesocodigo*/
public String getUnidadmedidapesocodigo(){
  return unidadmedidapesocodigo;
}
/**Fija el valor de unidadmedidapesocodigo
@param pUnidadmedidapesocodigo nuevo Valor de unidadmedidapesocodigo*/
public void setUnidadmedidapesocodigo(String pUnidadmedidapesocodigo){
  unidadmedidapesocodigo=pUnidadmedidapesocodigo;
}

/**Obtiene el valor de clasecodigo
@return valor de clasecodigo*/
public String getClasecodigo(){
  return clasecodigo;
}
/**Fija el valor de clasecodigo
@param pClasecodigo nuevo Valor de clasecodigo*/
public void setClasecodigo(String pClasecodigo){
  clasecodigo=pClasecodigo;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmTipoArmaExplosivo))return false;
    TarmTipoArmaExplosivo that = (TarmTipoArmaExplosivo) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmTipoArmaExplosivo
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmTipoArmaExplosivo
*/
public Object createInstance(){
 TarmTipoArmaExplosivo instance=new TarmTipoArmaExplosivo();	
 return instance;
}
/**Clona la entidad TarmTipoArmaExplosivo
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmTipoArmaExplosivo p=(TarmTipoArmaExplosivo)this.clone();
  return p;
}
}
